import React, { Component } from 'react';

import './App.css';
import Tree from './lib/TreeContainer';
import Expandable from './lib/renderers/Expandable';
import Favorite from './lib/renderers/Favorite';
import Deletable from './lib/renderers/Deletable';
import { Nodes } from './testData/sampleTree';

class App extends Component {
  state = {
    nodes: Nodes
  }

  handleChange = (nodes) => {
    this.setState({ nodes });
  }

  render() {
    return (
      <div className="App">
        <Tree list={this.state.nodes} onChange={this.handleChange}>
          {
            ({ node, ...rest }) =>
              <Expandable node={node} {...rest}>
                { node.name }
                <Deletable node={node} {...rest}>
                  <Favorite node={node} {...rest}/>
                </Deletable>
              </Expandable>
          }
        </Tree>
      </div>
    );
  }
}

export default App;
